#ADD
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( da : in std_logic_vector(|Bits-| downto 0);
           db : in std_logic_vector(|Bits-| downto 0);
           q  : out std_logic_vector(|Bits-| downto 0);
           ov : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
begin
  q  <= da + db;
  ov <= da(|Bits-|) and db(|Bits-|);
end Behavioral;
>


#SUB
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( da : in std_logic_vector(|Bits-| downto 0);
           db : in std_logic_vector(|Bits-| downto 0);
           q  : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  pSub: PROCESS(da,db)
        BEGIN
          IF da > db THEN q <= da - db; 
                     ELSE q <= |$0,Bits|;
          END IF;
        END PROCESS pSub;
end Behavioral;
>


#ADD_SUB
-Bits[2..36]
-OPERATION{ADD}[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( OP    : in std_logic;
           da    : in std_logic_vector(|Bits-| downto 0);
           db    : in std_logic_vector(|Bits-| downto 0);
           cin   : in std_logic;
           q     : out std_logic_vector(|Bits-| downto 0);
           ov,cb : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal ZW,V : std_logic_vector(|Bits-| downto 0);
begin
  pOP: PROCESS (cin,OP,da,db)
       variable TEMP : signed(2 downto 0); 
       BEGIN
         V <= |$0,Bits-| & cin;
         IF OP = '|Operation{Add}|' THEN
                       ZW <= da + db + V;
                       TEMP:= (ZW(|Bits-|),db(|Bits-|), da(|Bits-|));  
                       CASE TEMP is
                         WHEN "001"  => cb <= '1'; ov <= '0';    
                         WHEN "010"  => cb <= '1'; ov <= '0';    
                         WHEN "011"  => cb <= '0'; ov <= '1';    
                         WHEN "100"  => cb <= '1'; ov <= '1';    
                         WHEN "111"  => cb <= '1'; ov <= '0';    
                         WHEN OTHERS => cb <= '0'; ov <= '0';  
                       END CASE;  
                     ELSE
                       ZW <= da - db - V;
                       TEMP:= (ZW(|Bits-|), db(|Bits-|), da(|Bits-|));
                       CASE TEMP is
                         WHEN "001"  => cb <= '1'; ov <= '1';    
                         WHEN "010"  => cb <= '1'; ov <= '0';    
                         WHEN "100"  => cb <= '1'; ov <= '0';    
                         WHEN "110"  => cb <= '0'; ov <= '1';    
                         WHEN "111"  => cb <= '1'; ov <= '0';    
                         WHEN OTHERS => cb <= '0'; ov <= '0';  
                       END CASE;  
         END IF;

         q <= ZW;             
       END PROCESS pOP;
end Behavioral;
>

