{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit u_vhdlgen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ExtCtrls, u_srctemp, StdCtrls, Grids, u_datei, u_signals,
  u_komponente, u_automat, u_about;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    NeuesModul1: TMenuItem;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    Einstellungen1: TMenuItem;
    Hilfe1: TMenuItem;
    Modelpanel: TPanel;
    StatusBar: TStatusBar;
    PopupMenu1: TPopupMenu;
    OpenDialog1: TOpenDialog;
    SubAuswahlCB: TComboBox;
    EinstellungenGB: TGroupBox;
    BTNPanel: TPanel;
    makeHDLBTN: TButton;
    AbbruchBTN: TButton;
    StringGrid: TStringGrid;
    Automat1: TMenuItem;
    Testbench1: TMenuItem;
    N2: TMenuItem;
    MealyAutomat1: TMenuItem;
    N3: TMenuItem;
    Komponente_einfuegen: TMenuItem;
    Hilfe2: TMenuItem;
    About: TMenuItem;
    procedure BeendenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EinstellungenClick(Sender: TObject);
    procedure MenuSelectClick(Sender: TObject);
    procedure ShowEinstellPanel(b : boolean);
    procedure AbbruchBTNClick(Sender: TObject);
    procedure makeHDLBTNClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SubAuswahlCBChange(Sender: TObject);
    procedure StringGridKeyPress(Sender: TObject; var Key: Char);
    procedure StringGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure TestbenchClick(Sender: TObject);
    procedure Komponente_einfuegenClick(Sender: TObject);
    procedure MooreAutomatClick(Sender: TObject);
    procedure MealyAutomatClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure Hilfe2Click(Sender: TObject);
  private
    { Private-Deklarationen }
    progpath      : string;
    template      : string;
    srcpath       : string;
    TemplateDatei : string;
    model,valueList : TStringList;
    procedure ReadIniDatei;
    procedure WriteIniDatei;
    procedure writeHDLDatei(Datei : string; SrcList : TStringList);
    procedure BatchHDLSrc(Datei : string; var SrcList : TStringList);
    function  suche_ersetze(var ziel:string;suche,ersetze:string):byte;
  public
    { Public-Deklarationen }
    function dellzl(s:string) : string;     //entferne Leerzeichen von links
    function dellzr(s:string) : string;     //entferne Leerzeichen von rechts
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ReadIniDatei;
var F : TextFile;
    s : string;
    x : integer;
begin
  assignfile(F,progpath + 'VHDLGEN.INI');
  {$I-}
  reset(F);
  {$I+}
  if ioresult = 0 then
  begin
    x:= 0;
    while not eof(F) do
    begin
      readln(F,s);
      case x of
      0: srcpath:= s;
      end;
      inc(x);
    end;
    {$I-}
    CloseFile(F);
    {$I-}
  end;
end;

procedure TMainForm.WriteIniDatei;
var F : TextFile;
    s : string;
    x : integer;
const parametercnt = 1;
begin
  assignfile(F,progpath + 'VHDLGEN.INI');
  {$I-}
  rewrite(F);
  {$I+}
  if ioresult = 0 then
  begin
    for x:= 0 to parametercnt-1 do
    begin
      s:= '';
      case x of
      0: s:= srcpath;
      end;
      writeln(F,s);
    end;
    {$I-}
    CloseFile(F);
    {$I-}
  end;
end;

procedure TMainForm.BeendenClick(Sender: TObject);
begin
  close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var dir    : TSearchRec;
    weg1,s : string;
    err,i  : integer;
    NModul : TMenuItem;
begin
  TemplateDatei:= '';
  ShowEinstellPanel(false);
  StringGrid.Height:= EinstellungenGB.Height - SubAuswahlCB.Top - 2* SubAuswahlCB.Height;
  progpath:= ExtractFilePath(ParamStr(0));
  template:= progpath + 'Template\';
  srcpath:= progpath;
  ReadInidatei;
  model:= TStringList.Create;
  valueList:= TStringList.Create;

  weg1:=concat(template,'*.*');
  err:=findfirst(weg1,$2f,dir);
  while err = 0 do
  begin
    s:= copy(dir.name,pos('.',dir.name)+1,3);
    if uppercase(s) = 'VHD' then
    begin
      s:= copy(dir.name,1,pos('.',dir.name)-1);
      if length(s) > 0 then
      begin
        for i:= 1 to length(s) do
        begin
          if s[i] = '_' then s[i]:= ' ';
          if s[i] = '-' then s[i]:= ',';
        end;
        model.Add(s + '#' + dir.name);
      end;
    end;
    err:=findnext(dir);
  end;
  model.Sort;

  if model.Count > 0 then
  begin
    for i:= 0 to model.Count-1 do
    begin
      NModul:= TMenuItem.Create(NeuesModul1);
      s:= copy(Model.Strings[i],1,pos('#',Model.Strings[i])-1);
      s:= dellzr(s);
      NModul.Caption:= dellzl(s);
      NModul.OnClick:= MenuSelectClick;
      NModul.HelpContext:= 1170;
      NeuesModul1.Insert(i,NModul);
    end;

    NeuesModul1.Visible:= true;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var NModul,SubNM : TMenuItem;
begin
  while NeuesModul1.Count > 0 do
  begin
    NModul:= NeuesModul1.Items[0];

    while NModul.Count > 0 do
    begin
      SubNM:= NModul.Items[0];
      SubNM.Clear;
      SubNM.Free;
    end;

    NModul.Clear;
    NModul.Free;
  end;
  NeuesModul1.Clear;

  model.Free;
  ValueList.Free;
  WriteIniDatei;
end;

procedure TMainForm.FormResize(Sender: TObject);
var x : integer;
begin
  if width < 2 * AbbruchBTN.Width then width:= 2* AbbruchBTN.Width;
  x:= width div 2;
  AbbruchBTN.Left:= (x - AbbruchBTN.Width) div 2;
  MakeHDLBTN.Left:= x + AbbruchBTN.Left;
  StringGrid.Height:= EinstellungenGB.Height - SubAuswahlCB.Top -
                      2* SubAuswahlCB.Height;
end;

procedure TMainForm.EinstellungenClick(Sender: TObject);
var s,spath : string;
    i : integer;
begin
  OpenDialog1.Title:='Arbeitsverzeichnis auswhlen';
  OpenDialog1.InitialDir:= srcpath;
  OpenDialog1.FileName:= 'Ordner';
  OpenDialog1.Filter:= 'Ordner|*.';
  OpenDialog1.FilterIndex:= 0;
  if OpenDialog1.Execute then
  begin
    spath:='';
    s:= OpenDialog1.FileName;
    if pos('.',s) > 0 then spath:= ExtractFilePath(s);
    if ((pos('ORDNER',uppercase(s)) > 0) or (s[length(s)] <> '\')) then
    begin
      i:= length(s);
      while ((i > 0) and (s[i] <> '\')) do
        dec(i);
     spath:= copy(s,1,i);
    end;
    if spath <> '' then srcpath:= spath;
  end;
end;

procedure TMainForm.MenuSelectClick(Sender: TObject);
var srctemp : TSrcTemp;
    s       : String;
    i       : integer;
    SubItemList : TStringList;
begin
  TemplateDatei:= '';
  with Sender as TMenuItem do
  begin //Caption Menuindex
    s:= Model.Strings[Menuindex];
    i:= pos('#',s)+1;
    s:= copy(s,i,length(s)- i +1);
    StatusBar.SimpleText:= 'Read: ' + s;
    ValueList.Clear;
    TemplateDatei:= template + s;
    srctemp:= TSrctemp.Create(TemplateDatei);
    SubItemList:= srctemp.SubItemList;
    ValueList.AddStrings(srctemp.ValueItemList);
    if SubItemList <> nil then
    begin
      SubAuswahlCB.Items.Clear;
      SubAuswahlCB.Items.AddStrings(srctemp.SubItemList);
      SubAuswahlCB.ItemIndex:=0;
      ShowEinstellPanel(true);
      SubAuswahlCBChange(Self);
    end;
    srctemp.Free;
  end;
end;

procedure TMainForm.ShowEinstellPanel(b : boolean);
begin
  if b then
  begin
    NeuesModul1.Visible:= false;
    SubAuswahlCB.Visible:= true;
    EinstellungenGB.Visible:= true;
    BTNPanel.Visible:= true;
    AbbruchBTN.Visible:= true;
    makeHDLBTN.Visible:= true;
    StringGrid.Visible:= true;
  end
  else begin
         NeuesModul1.Visible:= true;
         SubAuswahlCB.Visible:= false;
         EinstellungenGB.Visible:= false;
         BTNPanel.Visible:= false;
         AbbruchBTN.Visible:= false;
         makeHDLBTN.Visible:= false;
         StringGrid.Visible:= false;
         StatusBar.SimpleText:= '';
       end;
end;

procedure TMainForm.SubAuswahlCBChange(Sender: TObject);
var vs,s,sWB : string;
    i,n,x,w  : integer;
begin
  w:= 10;
  StringGrid.ColCount:= 2;
  StringGrid.RowCount:= 100;

  StringGrid.Rows[0].clear;
  StringGrid.Rows[1].Clear;
  StringGrid.Rows[2].Clear;

  StringGrid.Cols[0].Clear;
  StringGrid.Cols[1].Clear;

  StringGrid.RowCount:= 2;

  StringGrid.Cols[0].Add('Auswahl');
  StringGrid.Cols[1].Add('Variable');
  StringGrid.Refresh;

  if valueList <> nil then
  begin
    i:= SubAuswahlCB.ItemIndex;
    if valueList.Count > i then
    begin
      vs:= valueList.Strings[i];
      while vs <> '' do
      begin
        n:= pos('|',vs);
        if n > 0 then
        begin
          s:= copy(vs,1,n-1);
          delete(vs,1,n);
        end
        else begin
               s:= vs;
               vs:='';
             end;

        StringGrid.RowCount:= StringGrid.RowCount +1;
        StringGrid.Cols[0].Add(s);
        if length(s) > w then w:= length(s);

        x:= pos('[',s);
        if x > 0 then
        begin
          sWB:= copy(s,x+1,length(s)-x-1);
          x:= pos(',',sWB);
          if x > 0 then sWB:= copy(sWB,1,x-1);
          x:= pos('.',sWB);
          if x > 0 then sWB:= copy(sWB,1,x-1);
          StringGrid.Cols[1].Add(sWB);
        end
        else StringGrid.Cols[1].Add('0');

      end;
      StringGrid.FixedCols:=1;
      StringGrid.FixedRows:=1;
    end;
  end;
  if StringGrid.RowCount > 2 then StringGrid.RowCount:= StringGrid.RowCount-1;
  StringGrid.DefaultColWidth:= w * StringGrid.Font.Size;
  StringGrid.Refresh;
end;

procedure TMainForm.AbbruchBTNClick(Sender: TObject);
begin
  ShowEinstellPanel(false);
end;

procedure TMainForm.makeHDLBTNClick(Sender: TObject);
var srctemp : TSrcTemp;
    Datname,Defdatname : string;
    SrcList : TStringList;
    dname   : TDateinameForm;
begin
  ShowEinstellPanel(false);
  StatusBar.SimpleText:= 'Erzeuge VHDL-Datei ';

  //create VHDL Datei
  SrcList:= TStringList.Create;
  if TemplateDatei <> '' then
  begin
    srctemp:= TSrcTemp.Create(TemplateDatei);
    srctemp.GetHDLSrc(SrcList,SubAuswahlCB.Items[SubAuswahlCB.itemindex]);
    srctemp.Free;

    if SrcList.Count > 0 then
    begin
      //Dateiname
      defdatname:= ExtractFilename(TemplateDatei);
      dname:= TDateinameForm.Create(Self);
      dname.Init(defdatname);
      dname.ShowModal;
      Datname:= dname.GetDateiname;
      dname.Free;
      if Datname = '' then Datname:= defdatname;

      if Datname <> '' then
      begin
        Datname:= srcpath + Datname;
        if pos('.',Datname) = 0 then Datname:= Datname + '.VHD';

        if FileExists(Datname) then
        begin
          if Application.MessageBox('Datei berschreiben?','Frage',mb_YesNo) = ID_NO then
          begin
            ShowEinstellPanel(true);
            exit;
          end;
        end;

        BatchHDLSrc(Datname,SrcList);
        writeHDLDatei(Datname,SrcList);
        StatusBar.SimpleText:= 'Fertig';
      end;
    end;

    SrcList.Free;
  end;
end;

procedure TMainForm.writeHDLDatei(Datei : string; SrcList : TStringList);
var F : TextFile;
    i : integer;
begin
  assignfile(F,Datei);
  {$I-}
  rewrite(F);
  {$I+}
  if ioresult = 0 then
  begin
    for i:= 0 to SrcList.Count-1 do
    begin
      writeln(F,SrcList.Strings[i]);
    end;
    closefile(F);
  end;
end;

procedure TMainForm.BatchHDLSrc(Datei : string; var SrcList : TStringList);
var i,n,x,k          : integer;
    b                : boolean;
    s,sx,sn,sz,sv,sa : string;
    Dateiname        : string;
    tmpList          : TStringList;
begin
  Dateiname:= ExtractFilename(Datei);
  if SrcList.Count > 0 then
  begin
    tmpList:= TStringList.Create;

    for i:= 0 to SrcList.Count-1 do
    begin
      s:= SrcList.Strings[i];
      //Batch
      suche_ersetze(s,'|NAME|',copy(Dateiname,1,pos('.',Dateiname)-1));
      for n:=1 to StringGrid.Rowcount-1 do
      begin
        sx:= StringGrid.Cols[0].Strings[n];
        x:= pos('[',sx);
        if x > 0 then sx:= copy(sx,1,pos('[',sx)-1);
        sx:= '|' + sx + '|';
        sn:= StringGrid.Cols[1].Strings[n];
        suche_ersetze(s,sx,sn);
        sx:= copy(sx,1,length(sx)-1);

        sx:= sx + '-|';
        k:= strtointdef(sn,0);
        if k > 0 then dec(k);
        sn:= inttostr(k);
        suche_ersetze(s,sx,sn);
      end;

      x:= pos('|$',s);
      if x > 0 then
      begin
        sx:= copy(s,x+1,length(s)-x);
        x:= pos('|',sx);
        sx:= copy(sx,1,x);
        sx:= '|' + sx;
        sn:= copy(sx,2,length(sx)-1);
        if sn <> '' then
        begin
          if sn[1] = '$' then
          begin
            sn:= copy(sn,2,pos('|',sn)-2);
            sz:= sn;
            x:= length(sn);
            while ((x > 0) and (sn[x] <> ',')) do
            begin
              if sn[x] <> ',' then delete(sn,length(sn),1);
              dec(x);
            end;
            delete(sn,length(sn),1);

            if sn <> '' then
            begin
              if length(sn) <= length(sz) then
              begin
                delete(sz,1,length(sn)+1);
                x:= pos('-',sz);
                b:= false;
                if x > 0 then
                begin
                  delete(sz,x,1);
                  b:= true;
                end;

                k:= 0;
                for n:=1 to StringGrid.Colcount+1 do
                begin
                  sv:= StringGrid.Cols[0].Strings[n];
                  x:= pos('[',sv);
                  if x > 0 then sv:= copy(sv,1,pos('[',sv)-1);

                  if (uppercase(sv) = uppercase(sz)) then //Variable gefunden
                      k:= strtointdef(StringGrid.Cols[1].Strings[n],0);
                end;

                sa:= '';
                if k > 0 then
                begin
                  if b then dec(k);
                  if k > 0 then
                  begin
                    for x:=1 to k do
                        sa:= sa + sn;
                  end;

                  sa:= #$22 + sa + #$22;
                  suche_ersetze(s,sx,sa);
                end;
              end;
            end;
          end;
        end;
      end;

      tmpList.Add(s);
    end;

    SrcList.Clear;
    for i:= 0 to TmpList.Count-1 do
    begin
      SrcList.Add(TmpList.Strings[i]);
    end;
    tmpList.Free;
  end;
end;

function TMainForm.dellzl(s:string) : string;     //entferne Leerzeichen von links
var i : integer;
begin
  i:= length(s);
  while i > 0 do
  begin
    if s[1] = ' ' then delete(s,1,1)
                  else i:=1; //Abbruch
    dec(i);
  end;
  result:= s;
end;

function TMainForm.dellzr(s:string) : string;     //entferne Leerzeichen von rechts
var i :integer;
begin
  i:= length(s);
  while i > 0 do
  begin
    if s[i] = ' ' then delete(s,i,1)
                  else i:= 1; //Abbruch
    dec(i);
  end;
  result:= s;
end;

function TMainForm.suche_ersetze(var ziel:string;suche,ersetze:string):byte;
var posit : byte;
begin
  posit := pos(uppercase(suche),uppercase(ziel));
  while posit <> 0 do
  begin
    ziel := copy(ziel,1,posit-1) + ersetze +
      copy(ziel,posit+length(suche),length(ziel)-length(suche)+1-posit);
    posit := pos(uppercase(suche),uppercase(ziel));
  end;
  suche_ersetze := posit;
end;

procedure TMainForm.StringGridKeyPress(Sender: TObject; var Key: Char);
begin
  //nur Zahlen zulassen
  if Key in ['0'..'9',#13] then
    else Key:= #0;
end;

procedure TMainForm.StringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var n,i,x,xmin,xmax,xtmp,xvalue : integer;
    s,vs,sWB : string;
begin
  if value <> '' then
  begin
    sWB:= '';
    // ueberpruefe Wertebereich
    if valueList <> nil then
    begin
      i:= SubAuswahlCB.ItemIndex;
      if valueList.Count > i then
      begin
        x:= 1;
        vs:= valueList.Strings[i];
        while vs <> '' do
        begin
          n:= pos('|',vs);
          if n > 0 then
          begin
            s:= copy(vs,1,n-1);
            delete(vs,1,n);
          end
          else begin
                 s:= vs;
                 vs:='';
               end;

          if x = ARow then
          begin      //Parameter gefunden
            sWB:= s;
            vs:= ''; //Abbruch
          end;
          inc(x);
        end; //while

        if sWB <> '' then
        begin
          x:= pos('[',sWB);
          if x > 0 then
          begin
            sWB:= copy(sWB,x+1,length(sWB)-x +1);
            x:= pos(']',sWB);
            sWB:= copy(sWB,1,x-1);

            xmin:= 0;
            xmax:= 0;
            n:= pos(',',sWB);
            if n > 0 then
            begin
              xmin:= strtointdef(copy(sWB,1,n-1),0);
              xmax:= strtointdef(copy(sWB,n+1,length(sWB)-n),0);
            end;

            n:= pos('..',sWB);
            if n > 0 then
            begin
              s:= copy(sWB,1,n-1);
              xmin:= strtointdef(copy(sWB,1,n-1),0);
              s:= copy(sWB,n+2,length(sWB)-n-1);
              xmax:= strtointdef(copy(sWB,n+2,length(sWB)-n-1),0);
            end;

            if xmin > xmax then
            begin
              xtmp:= xmax;
              xmax:= xmin;
              xmin:= xtmp; 
            end;

            if xmin <= xmax then
            begin
              xvalue:= strtointdef(value,0);
              if ((xvalue < xmin) or (xvalue > xmax)) then
                  StringGrid.Cells[ACol,ARow] := inttostr(xmin);
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TMainForm.TestbenchClick(Sender: TObject);
var vhdl_datei,tb_datei,s : string;
    n,i     : integer;
    tbstr : TStringList;
    F_tb  : TEXTFILE;
    rvhdl : TSignal;
begin
  ShowEinstellPanel(false);
  StatusBar.SimpleText:='Erzeuge Testbench';
  OpenDialog1.Title:='VHDL-Datei fr Testbench auswhlen';
  OpenDialog1.InitialDir:= srcpath;
  OpenDialog1.FileName:= '';
  OpenDialog1.Filter:= 'VHDL-Datei (*.vhd)|*.vhd';
  OpenDialog1.FilterIndex:= 0;
  if OpenDialog1.Execute then
  begin
    vhdl_datei:= OpenDialog1.FileName;
    tb_datei:= vhdl_datei;
    n:= pos('.',tb_datei);
    if n > 0 then
    begin
      delete(tb_datei,n,length(tb_datei)-n+1);
    end;
    tb_datei:= tb_datei + '.wdl';

    rvhdl:= TSignal.Create(vhdl_datei);
    tbstr:= rvhdl.componentdef(3);

    if tbstr <> nil then
    begin
      assignfile(F_tb,tb_datei);
      {$I-}
      rewrite(F_tb);
      {$I+}
      if ioresult = 0 then
      begin
        //Testbenchfile erzeugen
        writeln(F_tb,'library IEEE;');
        writeln(F_tb,'use IEEE.STD_LOGIC_1164.ALL;');
        writeln(F_tb,'use IEEE.STD_LOGIC_ARITH.ALL;');
        writeln(F_tb,'use IEEE.STD_LOGIC_UNSIGNED.ALL;');
        writeln(F_tb,'use work.testpack.ALL;');
        writeln(F_tb,'');
        writeln(F_tb,'entity testbench is');
        writeln(F_tb,'end testbench;');
        writeln(F_tb,'');
        writeln(F_tb,'architecture behavioral of testbench is');
        writeln(F_tb,'');
        //Component einfuegen
        if tbstr.Count > 0 then
        begin
          for i:= 0 to tbstr.Count-1 do
          begin
            s:= tbstr.Strings[i];
            writeln(F_tb,s);
          end;
        end;

        writeln(F_tb,'');
        //Signale fuer Darstellung definieren
        tbstr:= rvhdl.signalindef(3);
        if tbstr.Count > 0 then
        begin
          for i:= 0 to tbstr.Count-1 do
          begin
            s:= tbstr.Strings[i];
            writeln(F_tb,s);
          end;
        end;
        tbstr:= rvhdl.signaloutdef(3);
        if tbstr.Count > 0 then
        begin
          for i:= 0 to tbstr.Count-1 do
          begin
            s:= tbstr.Strings[i];
            writeln(F_tb,s);
          end;
        end;

        writeln(F_tb,'');
        writeln(F_tb,'   constant tb_time : time:= 100 ns; -- Zeitkonstante definieren');
        writeln(F_tb,'');

        writeln(F_tb,'BEGIN');
        writeln(F_tb,'');

        //Map port eirfuegen
        tbstr:= rvhdl.TBMapPort(3);
        if tbstr.Count > 0 then
        begin
          for i:= 0 to tbstr.Count-1 do
          begin
            s:= tbstr.Strings[i];
            writeln(F_tb,s);
          end;
        end;
        writeln(F_tb,'');

        //Simulation Testbench
        tbstr:= rvhdl.getclkrst(3);
        if tbstr.Count > 0 then
        begin
          for i:= 0 to tbstr.Count-1 do
          begin
            s:= tbstr.Strings[i];
            writeln(F_tb,s);
          end;
        end;

        writeln(F_tb,'');
        writeln(F_tb,'   ptest : PROCESS');
        writeln(F_tb,'           BEGIN');
        writeln(F_tb,'');
        writeln(F_tb,'');
        writeln(F_tb,'           wait; -- Test beendet');
        writeln(F_tb,'           END PROCESS ptest;');

        writeln(F_tb,'');
        writeln(F_tb,'END behavioral;');
        writeln(F_tb,'');

        closefile(F_tb);
      end;
    end;
  end;
  ShowEinstellPanel(false);
end;

procedure TMainForm.Komponente_einfuegenClick(Sender: TObject);
var vhdl_datei : string;
    komp : TKomponenteForm;
begin
  ShowEinstellPanel(false);
  StatusBar.SimpleText:='Komponente einfgen';
  OpenDialog1.Title:='VHDL-Datei, in welche eine Komponent eingefgt werden soll';
  OpenDialog1.InitialDir:= srcpath;
  OpenDialog1.FileName:= '';
  OpenDialog1.Filter:= 'VHDL-Datei (*.vhd)|*.vhd';
  OpenDialog1.FilterIndex:= 0;
  if OpenDialog1.Execute then
  begin
    vhdl_datei:= OpenDialog1.FileName;
    komp:= TKomponenteForm.Create(Self);
    komp.Init(srcpath,vhdl_datei);
    komp.ShowModal;
    komp.Free;
  end;
end;

procedure TMainForm.MooreAutomatClick(Sender: TObject);
var AForm : TAutomatForm;
begin //Moore
  AForm:= TAutomatForm.Create(Self);
  AForm.Init(progpath,srcpath,true);
  AForm.ShowModal;
  AForm.Free;
end;

procedure TMainForm.MealyAutomatClick(Sender: TObject);
var AForm : TAutomatForm;
begin //Mealy
  AForm:= TAutomatForm.Create(Self);
  AForm.Init(progpath,srcpath,false);
  AForm.ShowModal;
  AForm.Free;
end;

procedure TMainForm.AboutClick(Sender: TObject);
var about : TAboutBox;
begin
  about:= TAboutBox.Create(Self);
  about.ShowModal;
  about.Free;
end;

procedure TMainForm.Hilfe2Click(Sender: TObject);
begin
  Application.HelpJump('1000');
end;

end.

